//+------------------------------------------------------------------+
//|                                               FFT_and_Future.mq4 |
//|                                                 Copyright  2008 |
//|                                    m_keeper@mail.ru klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008."
#property link      "m_keeper@mail.ru"
//---
#include <stdlib.mqh>
#define pi 3.14159265358979323846
//---
#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import
//---
#property indicator_chart_window
//indicator_chart_window
//indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DarkOrange
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 1
//---- buffers
double SpecktrBuffer[];
double SpecktrBufferF[];
//---

//          
//1)      
//2)  
//     http://codebase.mql4.com/ru/672
//  :
// -  
//- -   
extern double n=9;//    -  
extern int InPast=200;//    ,   
extern int Futur=100;//     
extern double Gladkost=2;//   -  
//    M1-M15

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexStyle(1,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexBuffer(0,SpecktrBuffer);
SetIndexBuffer(1,SpecktrBufferF);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int tnn1=MathPow(2,n);//   -      
   double aa[];
   double pow[];
   double line[];
   
   int futur=Futur;
   int N=ArrayResize(aa,tnn1);
       N=ArrayResize(line,tnn1);
       N=ArrayResize(pow,tnn1);
   SetIndexDrawBegin(0,Bars-N-InPast);
   SetIndexDrawBegin(1,Bars-InPast);
   
   
   SetIndexShift(0, -InPast+futur);
   SetIndexShift(1, -InPast+futur);
   
   
   double sig;
   double openline=Close[N-1+InPast];
   double closeline=Close[InPast];
   for(int i=N-1; i>=0; i--)// ,  
   {
      sig=Close[i+InPast];
      line[i]=  (closeline-openline)*futur/(N-1.0)+(openline*(i)+closeline*(N-1.0-i))/(N-1.0);
      if (i==N-1)
      {
      aa[i]=sig                                   -(openline*(i)+closeline*(N-1.0-i))/(N-1.0);
      }else{
      aa[i]=((N-1.0-i)*(sig-(openline*(i)+closeline*(N-1.0-i))/(N-1.0))+aa[i+1]*(i+0.0))/(N-1.0);
      }
      
   }

   //    -      aa[] - 
   realfastfouriertransform(aa, tnn1, false); 

   
   double tmp=0;
   double power=0;
   double amp=0;
   double faz=0;

for( i=1; i<N/2; i++)
   {
      tmp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      pow[i]=tmp;
      if(tmp>power)power=tmp;
   }
   
double period=0;
for( i=1; i<N/2; i++)//     
   {
      period=(N+0.0)/(i+0.0);
      amp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      amp=amp*MathPow(amp/power,Gladkost);
      double sdvig;
      double pravo;
      if(aa[i*2]>0){pravo=1;}else{pravo=0;}
      if((pravo==0)){sdvig=pi;}else{sdvig=0;}
      faz=MathArctan(aa[i*2+1]/aa[i*2])+futur*2*pi/period+sdvig; 
      aa[i*2]=amp*MathCos(faz);
      aa[i*2+1]=amp*MathSin(faz);
   }
   
 /*for( i=1; i<N/2; i++)
   {
      power+=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
   }
   double porog=power*Porog;
 for( i=1; i<N/2; i++)//  
   {
      //   
      tmp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      if(tmp<porog)
      {
      aa[i*2]=0;
      aa[i*2+1]=0;
      }
   }//*/


   
   
   realfastfouriertransform(aa, tnn1, true);//    
   for( i=0; i<N; i++)
   {
     // SpecktrBuffer[i]=pow[i+1];
      SpecktrBuffer[i]=aa[i]+line[i];
      SpecktrBufferF[i]=SpecktrBuffer[i];
   }

   return(0);
  }
  
//+------------------------------------------------------------------+

//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])// ,  
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+